* ------------------------------------------------------------
*    PCM call subroutine for Mercury Unit
*                                             (C)1995 nenetto
* ------------------------------------------------------------
* $Id: __pcm.s,v 1.1 1995-03-11 00:36:36+0900 nenetto Exp nenetto $
*
		.xdef		__pcmout
*		.xdef		__pcminp
*		.xdef		__pcmaot
*		.xdef		__pcmain
*		.xdef		__pcmlot
*		.xdef		__pcmlin
*		.xdef		__pcmsns
		.xdef		__pcmmod
		.xdef		__mercury_check


DMAC_CH2	equ	$e84080
DMAC_CH3	equ	$e840c0
MERCURY_DATA	equ	$ecc080
MERCURY_COMMAND	equ	$ecc091
MERCURY_STATUS	equ	$ecc0a1

		.offset	0
D_in:		.ds.w	1	
Db_rate:	.ds.b	1	
Db_pan:		.ds.b	1	
D_length:	.ds.l	1	
P_data:		.ds.l	1	
buffer_length:
		.text

* ------------------------------------------------------------
*	IOCS _ADPCMOUT ʌ݊R[
*
*	input	d0.l : ----
*		d1.l : pcm rate*$100 +panpot
*		d2.l : data length
*		a1.l : data address
*	output	d0.l : ----
*
*	pcm rate... 0: 32 kHz   MONO
*		    1: 44.1 kHz MONO
*		    2: 48 kHz   MONO
*		    3: 32 kHz   STEREO
*		    4: 44.1 kHz STEREO
*		    5: 48 kHz   STEREO
*
*	panpot...   0:----
*		    1:  L ch
*		    2:  R ch
*		    3:L+R ch

__pcmout:
		movem.l	d0-d7/a0-a6,-(sp)
		
		lea	B_buff,a6
		movem.l	d1-d2/a1,D_in(a6)
		
		 bsr	__mercury_init
		 bsr	__mk_chain_table
		 bsr	__pcm_play
		
		movem.l	(sp)+,d0-d7/a0-a6
		rts


* ------------------------------------------------------------
*	IOCS _ADPCMMOD ʌ݊R[
*
*	input	d0.l : ----
*		d1.l : 0(stop), 1(pause), 2(continue)
*	output	d0.l : ----
*
__pcmmod:
		movem.l	d0-d7/a0-a6,-(sp)
		
		lea	DMAC_CH2,a0
		cmp.b	#1,d1
		beq	1f
		cmp.b	#2,d1
		beq	2f
		move.b	#%0001_0000,7(a0)	* soft abort
		bra	9f
	1:	move.b	#%0010_0000,7(a0)	* dma halt
		bra	9f
	2:	move.b	#%0000_0000,7(a0)	* release halt
	9:	
		movem.l	(sp)+,d0-d7/a0-a6
		rts


* ------------------------------
* Set Mercury-Unit command port.
*
__mercury_init:
		lea	DMAC_CH2,a0
		move.w	#-1,(a0)
		move.b	#%0001_0000,7(a0)	* soft abort
		
		move.b	#%1001_0011,MERCURY_COMMAND
						* gate off
		
	@@:	btst.b	#0,(a0)
		beq	@b
		clr.w	MERCURY_DATA		* output Lch zero
	@@:	btst.b	#0,(a0)
		bne	@b
		clr.w	MERCURY_DATA		* output Rch zero
		
		moveq	#0,d0
		move.b	Db_rate(a6),d0
		move.b	T_unit_com(pc,d0.w),d1	* CLOCK SELECT
		move.b	Db_pan(a6),d0
		lsl.b	#2,d0
		andi.b	#%1100,d0
		or.b	d0,d1			* PANPOT
		move.b	d1,MERCURY_COMMAND
		rts

T_unit_com:	.dc.b	%1001_0001		* 32kHz mono
		.dc.b	%1010_0001		* 44kHz
		.dc.b	%1011_0001		* 48kHz
		.dc.b	%1001_0011		* 32kHz stereo
		.dc.b	%1010_0011		* 44kHz
		.dc.b	%1011_0011		* 48kHz
		.even
		*	 ^			MASTER CLOCK  0:low / 1:high   (V3.5)
		*	  ^			INPUT SELECT  0:optical / 1:corexial
		*	   ^^			CLOCK SELECT  00: BCKex / 01-11: BCKint
		*	      ^^		PANPOT RG,LG
		*		^		STEREO/MONO
		*		 ^		OUT/IN



* ------------------------------
* Make chain table. for 16bit
*
__mk_chain_table:
		move.l	P_data(a6),d0
		move.l	D_length(a6),d1
		lea	B_chain_table,a1
		
		2:	move.l	d0,(a1)+
			add.l	#$fffc*2,d0
			move.w	#$fffc,(a1)+
			move.l	a1,(a1)
			add.l	#4,(a1)+
		sub.l	#$fffc*2,d1
		bgt	2b
		add.l	#$fffc*2,d1
		lsr.l	#1,d1
		move.w	d1,-6(a1)
	3:	clr.l	-(a1)
		rts


* ------------------------------
* Play 16bitPCM.
*
__pcm_play:
		lea	DMAC_CH2,a0
		move.w	#-1,(a0)			* CSR error clear
		move.b	#%0001_0000,7(a0)		* CCR
		*	  ^				* STR /1:start
		*	   ^				* CNT /1:continue use
		*	    ^				* HLT /1:halt
		*	     ^				* SAB /1:soft abort
		*	       ^			* INT /1:int enable
		move.w	#-1,(a0)			*  error clear
		move.b	#%1000_1000,4(a0)		* DCR
		*	       ^			*  16bit port
		move.b	#%0001_1110,5(a0)		* OCR
		*	    ^^				*  operand 16bit
		move.b	#%0000_0100,6(a0)		* SCR
		*	       ^^			*  memory count inc.
		move.l	#MERCURY_DATA,$14(a0)		* DAR
		move.l	#B_chain_table,$1c(a0)		* BAR .l
		
	@@:	btst.b	#0,(a0)				* dmac ch2 PCL
		beq	@b				* wait 'R'>'L' clock
	@@:	btst.b	#0,(a0)
		bne	@b				* wait 'L'>'R' clock
		move.b	#%1000_0000,7(a0)		* CCR
		rts


* ------------------------------
* Check Mercury-Unit
*
*	output	d0.l : -1(no unit), 0(V3.5`), 1(`V3.1)
*
__mercury_check:
		movem.l	a0-a1,-(sp)
		moveq	#-1,d0
		movea.l	a7,a0
		movea.l	8.w,a1
		move.l	#1f,8.w			* bus error vector
		tst.b	MERCURY_STATUS		* bus error > 1f
		move.l	a1,8.w
		move.b	#%0101_0011,MERCURY_COMMAND
		btst	#6,MERCURY_STATUS
		beq	2f
		move.b	#%0001_0011,MERCURY_COMMAND
		btst	#6,MERCURY_STATUS
		bne	2f
		moveq	#0,d0
		btst	#7,MERCURY_STATUS
		beq	2f
		moveq	#1,d0
		bra	2f
		
	1:	movea.l	a0,a7
		move.l	a1,8.w
	2:	movem.l	(sp)+,a0-a1
		rts


* ------------------------------------------------------------
		.bss
B_buff:		.ds.b	buffer_length
		.even
B_chain_table:	.ds.w	128*5
		.text

		.end
